// Fonctions d'utilisation d'un smaphore
//  Prise et liberation d'un smaphore mutex



#include "semaphor.h"


//* cration d'un semaphore UNIX */
int creesem(int cle, int init_val)
{
 int semid;

//* creation smaphore */
 if ((semid = semget(cle,1,IPC_CREAT+0666)) ==-1)
     { 
      return(-1);
     }
//* initialisation du smaphore  */
 if ((semctl(semid,0,SETVAL, init_val))==-1)
     {perror("pb initialisation");
      return(-1);
     }
 //printf("fin initialisation du semaphore\n");
 return(semid);
}

//* fonction de prise du smaphore */
int P(int semid)
{
int cptr;
static struct sembuf spv = {0,-1,0};
//printf(" blocage sur semsynchro \n");
cptr=semop(semid,&spv,1);
return cptr;
}



//* fonction de libration du smaphore */
int V(int semid)
{
int cptr;
static struct sembuf spv = {0, 1, 0};
cptr = semop(semid,&spv,1);
//printf("deblocage de synchro \n");
return cptr;
}





void detruisem(int semid)
{
   if ((semctl(semid,0, IPC_RMID,0))==-1)
   {
	perror("pb destruction");
	exit(0);
   }
   //printf("fin de destruction du semaphore\n");
}
