//fichier texec.C

//*************************************************************************/
//  Test de la fonction exec()     
//  Exemple de recouvrement du code d'un processus fils                                                                                          
/**************************************************************************/
   
#include <stdio.h>
#include <fcntl.h>  
#include <sys/types.h>  
#include <sys/unistd.h>
#include <sys/wait.h>
#include <stdlib.h>

void affvar(char *nom, pid_t pid)                           /* Definition de la fontion affvar */

{
 printf("processus %s : idfils =%d\n",nom,pid);
}

void pere(pid_t pidfils)                                /* Definition de la fonction pere */
{
 affvar("pere", pidfils);
}

void fils(pid_t pidfils)                                /* Definition de la fonction fils */
{
 sleep(1);
 affvar("fils",pidfils);
 execlp("ls","ls",(char *)0);
}


int main()                                
{
pid_t idfils;                         
idfils=fork();                // creation du processus fils    
 if (idfils ==-1)                   
    {
     perror("fork");
     exit(1);                       
    }
 if (idfils)  pere(idfils);   //pour le processus pre      
 else         fils(idfils);   //pour le processus fils
 return(1);
}


