/* Programme demo pour l'utilisation d'un smaphore et d'une memoire partagee
   Prise et liberation d'un smaphore lmentaire par un processus et son fils
   sem_shm_demo.C  
*/
#include <unistd.h>
#include <stdio.h>
#include <signal.h>
#include "semaphor.h"
#include "sharemem.h"
#include <sys/unistd.h>
#include <fcntl.h>

#define   CLE_SEM 414
#define CLE_MEM 415

int mutex, memid;
char *share_buf;
pid_t pid;

/*fonction traitant le cas d'une interruption  de programme avec CTRL C */
void inter()
{
  /*envoi d'une interruption au fils */
 kill (SIGINT, pid);
  
 /* destruction du semaphore */
  detruisem(mutex);
 /* destruction et detachement de la memoire */
 detach(share_buf,memid);

}

main()
{
int memid, k=0;
char *buf_fils, *buf_pere;

mutex = creesem(CLE_SEM, 1);
share_buf= (char *)creemem(CLE_MEM, 20, memid);




// creation d'un fils comme processus concurrent 
if (( pid=fork())==0)
    {
     buf_fils ="je suis le fils ";
    printf(" processus fils \n");

    // liberation du smaphore 
   if ((V(mutex))==-1)
      {
       perror("pb liberation fils");
      };

    while(1)
  {
   sleep(3);
   if ((P(mutex)) ==-1)
      {
       perror("pb prise fils");
      };
   printf("prise par fils\n");
   sleep(2);
   // depot du message dans la memoire partagee 
   ecrire( share_buf, buf_fils);
   printf ("contenu de la memoire partagee %s \n", share_buf);
   printf("liberation par fil \n");
   // liberation du smaphore 
   if ((V(mutex))==-1)
      {
       perror("pb liberation fils");
      };
   sleep(3);
   };
   
}
 else
    {
       signal(SIGINT,(void(*) (int)) inter);
     buf_pere = "je suis le pere ";
     sleep(3);
    printf("processus pere\n");
 while(1)
  {
  if ((P(mutex)) ==-1)
     { 
     perror("pb prise pere");
     };
   printf("prise par pere \n");
   sleep(6);
   printf ("contenu de la memoire partagee (pere) %s \n", share_buf);
   printf("liberation par pere \n");
   if ((V(mutex))==-1)
       {
        perror("pb liberation pere");
       };
   sleep(5);
   };
  };

}

