//Fonctions d'utilisation d'une memoire partagee
//  attachement, ecriture, lecture



#include "sharemem.h"



//* cration et attachement d'une memoire partagee UNIX */
void *creemem(int cle, int taille, int &memid)

{

 void *adr_mem;
 //* creation memoire */
 //printf ("creation memoire %d \n", cle);
 if ((memid = shmget(cle,taille,IPC_CREAT|0666)) ==-1)
     {
      perror("pb creation mem ");
      exit(2);
     }
//* attachement  */
 if (( adr_mem= (void *) shmat(memid,0,0))==NULL)
     {perror("pb attachement");
      exit(2);
     }
 //printf("fin creation memoire partagee\n");
 return(adr_mem);
}

//* fonction d ecriture dans memoire partagee caractere */
int ecrire(char *adr_mem, char *message)

{
strcpy(adr_mem, message);
return(0);
}

//* fonction de lecture dans memoire partagee */
int lire(char *adr_mem, char *message)

{
strcpy( message, adr_mem);
return(0);
}



//*fonction detachement */
void detach(void *adr_mem, int memid)
{
 if((shmdt(adr_mem) ==-1))
   perror("pb detachement memoire ");
 

  if ((shmctl(memid,0, IPC_RMID))==-1)
   {
	perror("pb destruction");
	exit(0);
   }
  //printf("fin detachement de la memoire partagee\n");
  exit(0);
}



 
